#lang scribble/manual

@;@(require racket-poppler/render-tex)
@;@(latex-path "/usr/bin/pdflatex")

@(define DrRacket (italic "DrRacket"))
@(define rack (italic "racket"))

@title{Programación 1 - Práctica 0}
 
@;section{Evalando Expresiones.}

@section{Expresiones aritméticas.}

@itemlist[#:style 'ordered 

@; ejercicio -------------------
@item{           
Considere las siguientes expresiones aritméticas:

@verbatim{12 * 5 - 7 * 6}
@verbatim{3 * 5 - 7 * 4 / 14 + 3 / 1}
@verbatim{cos(0.8) + 1/5 + sen(0.5) * 3.5}

@itemlist[#:style 'ordered
            @item{Exprese cada una de ellas con la sintaxis de @rack .}
            @item{Sin usar @DrRacket evalúe cada una de ellas.
           Aquí un ejemplo de cómo hacerlo para la expresión @racket[(* (+ 1 2) 3)]: 

           @racket[(* (+ 2 3) 4)]
           @verbatim{==}
           @racket[(* 5 4)]
           @verbatim{==}
           @racket[20]
            }
           @item{Usando @DrRacket, verifique los resultados obtenidos.}
           @item{Para algunas de las expresiones, realice la evaluación
           @italic{paso a paso}.}
          ]
}

@; ejercicio ---------------------
@item{Usando @DrRacket , evalúe las siguientes expresiones:
@margin-note{Quizás algunas de estas expresiones no denoten valores y resulten en error.
Es bueno entender qué mensaje recibimos en esos casos!}

          @itemlist[#:style 'ordered
            @item{@racket[(/ 1 (sin (sqrt 3)))]}  
            @item{@racket[(* (sqrt 2) (sin pi))]}
            @item{@racket[(+ 3 (sqrt (- 4)))]}
            @item{@racket[(* (sqrt 5) (sqrt (/ 3 (cos pi))))]}
            @item{@racket[(/ (sqrt 5) (sin (* 3 0)))]}
            @item{@racket[(/ (+ 3) (* 2 4))]}
            @item{@racket[(* 1 2 3 4 5 6 7 8)]}
            @item{@racket[(/ 120 2 3 2 2 5)]}      @;     @bold{(Asegúrese de entender el resultado de esta expresión)}}
          ]

}

@item{En los ejercicios anteriores aparecen algunas funciones como @racket[cos],
           @racket[sin], @racket[sqrt].
@margin-note{
      Si la mayoría de estos nombres no le dicen nada, no se preocupe,
      no es necesario conocerlas por ahora.}
           Muchas funciones que quizás le resulten conocidas ya se encuentran predefinidas en
      @DrRacket, tales como @racket[log], @racket[tan], @racket[expt],
           @racket[random], @racket[max], @racket[min], @racket[floor],
           @racket[ceiling], @racket[abs].  
      Escriba expresiones que combinen algunas de estas funciones. Si no conoce
      su comportamiento, consulte la documentación o a los docentes.
           
          } 
@; @item{Considere las siguientes definiciones:
@;
  @;     @racket[(define m 12)]
    @;   
  @;     @racket[(define n 8)]
@;
  @;     La expresión @racket[(* n m)] evalúa a @racket[96].
@;
  @;     Escriba una expresión que calcule 
    @;   }
          ] @; de los ejercicios

@section{Strings}
@itemlist[#:style 'ordered 
  @; ejercicio -------------------
  @item{Evalúe en @DrRacket las siguientes expresiones:
                  @itemlist[#:style 'ordered
                    @item{@racket[(string-append "Hola" "mundo")]}
                    @item{@racket[(string-append "Pro" "gra"  "ma.")]}
                    @item{@racket[(number->string  1357)]}
                    @item{@racket[(string-append "La respuesta es " (number->string (+ 21 21))) ]}
                    @item{@racket[(* (string-length "Hola") (string-length "Chau"))]}
                    ]
                  @margin-note{Recuerde que en Ciencias de la Computación contamos
           desde 0. }
        Explore la función @racket[string-ith], que, dados un string @racket[s]
           y un número natural @racket[n],
        devuelve el caracter que ocupa la @racket[n]-ésima posición en @racket[s].


          Más interesante es la función @racket[substring]. Aquí un ejemplo de cómo
        funciona:

           @racket[(substring "Programar" 2 5)]
           @verbatim{==}
           @racket["ogr"]

        Escriba expresiones que utilicen esta función ¿Qué sucede si el último
        argumento es menor que el penúltimo? ¿Y si son iguales?
          }
      
  ] @; de los ejercicios de la sección strings

@section{Valores de verdad}
@itemlist[#:style 'ordered 
  @; ejercicio -------------------
  @item{Evalúe en @DrRacket las siguientes expresiones:
        @itemlist[#:style 'ordered
                    @item{@racket[(not #t)]}
                    @item{@racket[(or #t #f)]}
                    @item{@racket[(and #t #f)]}
                    @item{@racket[(and #t (or #f (not #f)) (not #t))]}
                    @item{@racket[(not (= 2 (* 1 3)))]}
                    @item{@racket[(or (= 2 (* 1 3)) (< 4 (+ 3 2)))]}
                  ]
 }                 
]
@section{Imágenes}
@itemlist[#:style 'ordered 
  @; ejercicio -------------------
  @item{Este ejercicios presenta algunas expresiones con la intención
        de familiarizarse con imágenes.
        Modifique estas expresiones para observar el comportamiento de las
        funciones aquí presentadas.
        
        @itemlist[#:style 'ordered
                    @item{@racket[(circle 10 "solid" "red")]}
                    @item{@racket[(rectangle 10 20 "solid" "blue")]}
                    @item{@racket[(rectangle 20 12 "outline" "magenta")]}
                    @item{@racket[(overlay (rectangle 20 20 "solid" "blue")
                                           (circle 7 "solid" "green"))]}
                    @item{@racket[(empty-scene 100 100)]}
                    @item{@racket[(place-image (circle 10 "solid" "blue") 40 80 (empty-scene 100 100))]}
                    @item{@racket[(+ (image-width (circle 10 "solid" "red"))
   (image-height (rectangle 10 20 "solid" "blue")))]}
                  ]
 }                 
]


@section{Funciones}
@itemlist[#:style 'ordered 
  @; ejercicio -------------------
  @item{Defina una función que recibe dos números
           @racket[x] e @racket[y], devolviendo la distancia al origen del punto
           (x,y)}
  @item{Defina una función que recibe cuatro números
           @racket[x1], @racket[y1], @racket[x2] e @racket[y2];
           devolviendo la distancia entre los puntos (@racket[x1], @racket[y1])
          y (@racket[x2], @racket[y2])}
  
  @item{Defina la función @racket[vol-cubo] que recibe la longitud de la arista
  de un cubo y calcula su volumen.}
  @item{Defina la función @racket[area-cubo] que recibe la longitud de la arista
  de un cubo y calcula su área.}
  @item{Defina la función @racket[area-imagen] que recibe una imagen
           y calcula su área.
           Intente aplicar esta función a valores que no son imágenes}
  @item{Defina la función @racket[string-insert], que consume un string
           y un número @racket[i] e inserta "-" en la posición
          @racket[i]-ésima del string.}
                                                                      
  ]
@;Welcome to my documentation: @racket[(list 'testing 1 2 3)].







